/****************************************************************************
** Form implementation generated from reading ui file 'src/CustomizeShortcutsDialog.ui'
**
** Created by: The User Interface Compiler ($Id: qt/main.cpp   3.3.7   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "CustomizeShortcutsDialog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qheader.h>
#include <qlistview.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qframe.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a CustomizeShortcutsDialog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
CustomizeShortcutsDialog::CustomizeShortcutsDialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "CustomizeShortcutsDialog" );
    setMinimumSize( QSize( 0, 0 ) );
    setSizeGripEnabled( TRUE );
    CustomizeShortcutsDialogLayout = new QVBoxLayout( this, 11, 6, "CustomizeShortcutsDialogLayout"); 

    List = new QListView( this, "List" );
    List->addColumn( tr( "Focus" ) );
    List->addColumn( tr( "Key shortcut" ) );
    List->header()->setClickEnabled( FALSE, List->header()->count() - 1 );
    List->setAllColumnsShowFocus( TRUE );
    List->setRootIsDecorated( TRUE );
    CustomizeShortcutsDialogLayout->addWidget( List );

    layout6 = new QHBoxLayout( 0, 0, 6, "layout6"); 

    RadioButtonGroup = new QButtonGroup( this, "RadioButtonGroup" );
    RadioButtonGroup->setColumnLayout(0, Qt::Vertical );
    RadioButtonGroup->layout()->setSpacing( 6 );
    RadioButtonGroup->layout()->setMargin( 11 );
    RadioButtonGroupLayout = new QGridLayout( RadioButtonGroup->layout() );
    RadioButtonGroupLayout->setAlignment( Qt::AlignTop );

    NoneRButton = new QRadioButton( RadioButtonGroup, "NoneRButton" );

    RadioButtonGroupLayout->addWidget( NoneRButton, 0, 0 );

    CustomRButton = new QRadioButton( RadioButtonGroup, "CustomRButton" );

    RadioButtonGroupLayout->addWidget( CustomRButton, 0, 1 );
    layout6->addWidget( RadioButtonGroup );
    spacer2 = new QSpacerItem( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout6->addItem( spacer2 );

    EditButton = new QPushButton( this, "EditButton" );
    EditButton->setEnabled( FALSE );
    layout6->addWidget( EditButton );
    CustomizeShortcutsDialogLayout->addLayout( layout6 );

    line1 = new QFrame( this, "line1" );
    line1->setFrameShape( QFrame::HLine );
    line1->setFrameShadow( QFrame::Sunken );
    line1->setFrameShape( QFrame::HLine );
    CustomizeShortcutsDialogLayout->addWidget( line1 );

    layout5 = new QHBoxLayout( 0, 0, 6, "layout5"); 

    m_pWhatsThis = new QPushButton( this, "m_pWhatsThis" );
    m_pWhatsThis->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, m_pWhatsThis->sizePolicy().hasHeightForWidth() ) );
    layout5->addWidget( m_pWhatsThis );
    spacer1 = new QSpacerItem( 16, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout5->addItem( spacer1 );

    ApplyButton = new QPushButton( this, "ApplyButton" );
    layout5->addWidget( ApplyButton );

    OkButton = new QPushButton( this, "OkButton" );
    OkButton->setDefault( TRUE );
    layout5->addWidget( OkButton );

    CancelButton = new QPushButton( this, "CancelButton" );
    layout5->addWidget( CancelButton );
    CustomizeShortcutsDialogLayout->addLayout( layout5 );
    languageChange();
    resize( QSize(393, 405).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( ApplyButton, SIGNAL( clicked() ), this, SLOT( applyClicked() ) );
    connect( CancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( List, SIGNAL( currentChanged(QListViewItem*) ), this, SLOT( selected(QListViewItem*) ) );
    connect( NoneRButton, SIGNAL( clicked() ), this, SLOT( resetAccel() ) );
    connect( OkButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( EditButton, SIGNAL( clicked() ), this, SLOT( showGrabKeyboard() ) );
    connect( RadioButtonGroup, SIGNAL( clicked(int) ), this, SLOT( customizable(int) ) );
    connect( m_pWhatsThis, SIGNAL( clicked() ), this, SLOT( enterWhatsThisMode() ) );

    // tab order
    setTabOrder( List, NoneRButton );
    setTabOrder( NoneRButton, CustomRButton );
    setTabOrder( CustomRButton, EditButton );
    setTabOrder( EditButton, m_pWhatsThis );
    setTabOrder( m_pWhatsThis, ApplyButton );
    setTabOrder( ApplyButton, OkButton );
    setTabOrder( OkButton, CancelButton );
}

/*
 *  Destroys the object and frees any allocated resources
 */
CustomizeShortcutsDialog::~CustomizeShortcutsDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void CustomizeShortcutsDialog::languageChange()
{
    setCaption( tr( "Customize keyboard shortcuts" ) );
    List->header()->setLabel( 0, tr( "Focus" ) );
    List->header()->setLabel( 1, tr( "Key shortcut" ) );
    QWhatsThis::add( List, tr( "Select an item to customize keyboard shortcuts." ) );
    RadioButtonGroup->setTitle( QString::null );
    QWhatsThis::add( RadioButtonGroup, tr( "Choose 'None' to disable key shortcuts for the selected item, or 'Custom' to select a shortcut after a click into the field to the right." ) );
    NoneRButton->setText( tr( "None" ) );
    CustomRButton->setText( tr( "Custom" ) );
    EditButton->setText( tr( "&Edit" ) );
    EditButton->setAccel( QKeySequence( tr( "Alt+E" ) ) );
    QWhatsThis::add( EditButton, tr( "Click here to activate the key shortcut recorder for the selected item." ) );
    m_pWhatsThis->setText( QString::null );
    QToolTip::add( m_pWhatsThis, tr( "What's this? (Shift+F1)" ) );
    QWhatsThis::add( m_pWhatsThis, QString::null );
    ApplyButton->setText( tr( "&Apply" ) );
    ApplyButton->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    OkButton->setText( tr( "&OK" ) );
    OkButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    CancelButton->setText( tr( "&Cancel" ) );
    CancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

void CustomizeShortcutsDialog::resetAccel()
{
    qWarning( "CustomizeShortcutsDialog::resetAccel(): Not implemented yet" );
}

void CustomizeShortcutsDialog::applyClicked()
{
    qWarning( "CustomizeShortcutsDialog::applyClicked(): Not implemented yet" );
}

void CustomizeShortcutsDialog::selected(QListViewItem*)
{
    qWarning( "CustomizeShortcutsDialog::selected(QListViewItem*): Not implemented yet" );
}

void CustomizeShortcutsDialog::showGrabKeyboard()
{
    qWarning( "CustomizeShortcutsDialog::showGrabKeyboard(): Not implemented yet" );
}

void CustomizeShortcutsDialog::customizable(int)
{
    qWarning( "CustomizeShortcutsDialog::customizable(int): Not implemented yet" );
}

void CustomizeShortcutsDialog::enterWhatsThisMode()
{
    qWarning( "CustomizeShortcutsDialog::enterWhatsThisMode(): Not implemented yet" );
}

