/****************************************************************************
** Form implementation generated from reading ui file 'src/ModuleBrowser.ui'
**
** Created by: The User Interface Compiler ($Id: qt/main.cpp   3.3.7   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "ModuleBrowser.h"

#include <qvariant.h>
#include <qheader.h>
#include <qlistview.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a ModuleBrowser as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ModuleBrowser::ModuleBrowser( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ModuleBrowser" );
    setSizeGripEnabled( TRUE );
    ModuleBrowserLayout = new QVBoxLayout( this, 11, 6, "ModuleBrowserLayout"); 

    m_Modules = new QListView( this, "m_Modules" );
    m_Modules->addColumn( tr( "Modules" ) );
    m_Modules->addColumn( tr( "Modified" ) );
    ModuleBrowserLayout->addWidget( m_Modules );

    TextLabel1 = new QLabel( this, "TextLabel1" );
    ModuleBrowserLayout->addWidget( TextLabel1 );

    m_Choice = new QLineEdit( this, "m_Choice" );
    m_Choice->setReadOnly( TRUE );
    ModuleBrowserLayout->addWidget( m_Choice );

    layout1 = new QHBoxLayout( 0, 0, 6, "layout1"); 

    m_pWhatsThis = new QPushButton( this, "m_pWhatsThis" );
    m_pWhatsThis->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, m_pWhatsThis->sizePolicy().hasHeightForWidth() ) );
    m_pWhatsThis->setFlat( FALSE );
    layout1->addWidget( m_pWhatsThis );

    m_BrowseHorM = new QPushButton( this, "m_BrowseHorM" );
    layout1->addWidget( m_BrowseHorM );
    Spacer1 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( Spacer1 );

    m_OkButton = new QPushButton( this, "m_OkButton" );
    m_OkButton->setDefault( TRUE );
    layout1->addWidget( m_OkButton );

    m_CancelButton = new QPushButton( this, "m_CancelButton" );
    layout1->addWidget( m_CancelButton );
    ModuleBrowserLayout->addLayout( layout1 );
    languageChange();
    resize( QSize(410, 326).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( m_OkButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( m_CancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( m_Modules, SIGNAL( selectionChanged() ), this, SLOT( select() ) );
    connect( m_BrowseHorM, SIGNAL( clicked() ), this, SLOT( toggleBrowseHorM() ) );
    connect( m_pWhatsThis, SIGNAL( clicked() ), this, SLOT( enterWhatsThisMode() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ModuleBrowser::~ModuleBrowser()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ModuleBrowser::languageChange()
{
    setCaption( tr( "Browse Modules" ) );
    m_Modules->header()->setLabel( 0, tr( "Modules" ) );
    m_Modules->header()->setLabel( 1, tr( "Modified" ) );
    TextLabel1->setText( tr( "Selection:" ) );
    m_pWhatsThis->setText( QString::null );
    QToolTip::add( m_pWhatsThis, tr( "What's this? (Shift+F1)" ) );
    m_BrowseHorM->setText( QString::null );
    m_OkButton->setText( tr( "&OK" ) );
    m_OkButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    m_CancelButton->setText( tr( "&Cancel" ) );
    m_CancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

void ModuleBrowser::toggleBrowseHorM()
{
    qWarning( "ModuleBrowser::toggleBrowseHorM(): Not implemented yet" );
}

void ModuleBrowser::select()
{
    qWarning( "ModuleBrowser::select(): Not implemented yet" );
}

void ModuleBrowser::enterWhatsThisMode()
{
    qWarning( "ModuleBrowser::enterWhatsThisMode(): Not implemented yet" );
}

