/****************************************************************************
** Form implementation generated from reading ui file 'src/SshKeyDialog.ui'
**
** Created by: The User Interface Compiler ($Id: qt/main.cpp   3.3.7   edited Aug 31 2005 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "SshKeyDialog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a SshKeyDialog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
SshKeyDialog::SshKeyDialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "SshKeyDialog" );
    setSizeGripEnabled( TRUE );
    SshKeyDialogLayout = new QGridLayout( this, 1, 1, 11, 6, "SshKeyDialogLayout"); 

    m_GroupBox = new QGroupBox( this, "m_GroupBox" );
    m_GroupBox->setColumnLayout(0, Qt::Vertical );
    m_GroupBox->layout()->setSpacing( 6 );
    m_GroupBox->layout()->setMargin( 11 );
    m_GroupBoxLayout = new QGridLayout( m_GroupBox->layout() );
    m_GroupBoxLayout->setAlignment( Qt::AlignTop );

    m_EnterField = new QLineEdit( m_GroupBox, "m_EnterField" );

    m_GroupBoxLayout->addWidget( m_EnterField, 0, 0 );

    m_ListBox = new QListBox( m_GroupBox, "m_ListBox" );
    m_ListBox->setFocusPolicy( QListBox::WheelFocus );

    m_GroupBoxLayout->addMultiCellWidget( m_ListBox, 1, 4, 0, 0 );

    AddButton = new QPushButton( m_GroupBox, "AddButton" );

    m_GroupBoxLayout->addWidget( AddButton, 1, 1 );

    ModifyButton = new QPushButton( m_GroupBox, "ModifyButton" );

    m_GroupBoxLayout->addWidget( ModifyButton, 2, 1 );

    RemoveButton = new QPushButton( m_GroupBox, "RemoveButton" );

    m_GroupBoxLayout->addWidget( RemoveButton, 3, 1 );
    Spacer6 = new QSpacerItem( 20, 220, QSizePolicy::Minimum, QSizePolicy::Expanding );
    m_GroupBoxLayout->addItem( Spacer6, 4, 1 );

    BrowseButton = new QPushButton( m_GroupBox, "BrowseButton" );

    m_GroupBoxLayout->addWidget( BrowseButton, 0, 1 );

    SshKeyDialogLayout->addWidget( m_GroupBox, 0, 0 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    m_pWhatsThis = new QPushButton( this, "m_pWhatsThis" );
    m_pWhatsThis->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, m_pWhatsThis->sizePolicy().hasHeightForWidth() ) );
    layout2->addWidget( m_pWhatsThis );
    Spacer1 = new QSpacerItem( 260, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout2->addItem( Spacer1 );

    OkButton = new QPushButton( this, "OkButton" );
    OkButton->setDefault( TRUE );
    layout2->addWidget( OkButton );

    ResetButton = new QPushButton( this, "ResetButton" );
    ResetButton->setDefault( FALSE );
    layout2->addWidget( ResetButton );

    CancelButton = new QPushButton( this, "CancelButton" );
    layout2->addWidget( CancelButton );

    SshKeyDialogLayout->addLayout( layout2, 1, 0 );
    languageChange();
    resize( QSize(547, 442).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( AddButton, SIGNAL( clicked() ), this, SLOT( addClicked() ) );
    connect( ModifyButton, SIGNAL( clicked() ), this, SLOT( modifyClicked() ) );
    connect( RemoveButton, SIGNAL( clicked() ), this, SLOT( removeClicked() ) );
    connect( OkButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( CancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( m_pWhatsThis, SIGNAL( clicked() ), this, SLOT( enterWhatsThisMode() ) );
    connect( ResetButton, SIGNAL( clicked() ), this, SLOT( resetClicked() ) );
    connect( BrowseButton, SIGNAL( clicked() ), this, SLOT( browseClicked() ) );
    connect( m_ListBox, SIGNAL( clicked(QListBoxItem*) ), this, SLOT( listClicked(QListBoxItem*) ) );

    // tab order
    setTabOrder( m_EnterField, BrowseButton );
    setTabOrder( BrowseButton, AddButton );
    setTabOrder( AddButton, m_ListBox );
    setTabOrder( m_ListBox, ModifyButton );
    setTabOrder( ModifyButton, RemoveButton );
    setTabOrder( RemoveButton, m_pWhatsThis );
    setTabOrder( m_pWhatsThis, OkButton );
    setTabOrder( OkButton, ResetButton );
    setTabOrder( ResetButton, CancelButton );
}

/*
 *  Destroys the object and frees any allocated resources
 */
SshKeyDialog::~SshKeyDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void SshKeyDialog::languageChange()
{
    setCaption( tr( "Ssh Key Setup" ) );
    m_GroupBox->setTitle( QString::null );
    QToolTip::add( m_ListBox, QString::null );
    QWhatsThis::add( m_ListBox, tr( "<html>\n"
"<p>\n"
"Here the private key files for the ssh agent are listed.\n"
"</p>\n"
"</html>" ) );
    AddButton->setText( tr( "&Add" ) );
    AddButton->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    QWhatsThis::add( AddButton, tr( "Add the contents of the field to the left to the private ssh key list" ) );
    ModifyButton->setText( tr( "&Modify" ) );
    ModifyButton->setAccel( QKeySequence( tr( "Alt+M" ) ) );
    QWhatsThis::add( ModifyButton, tr( "Modify the selected entry" ) );
    RemoveButton->setText( tr( "&Remove" ) );
    RemoveButton->setAccel( QKeySequence( tr( "Alt+R" ) ) );
    QWhatsThis::add( RemoveButton, tr( "Remove the selected entry from the private ssh key file list" ) );
    BrowseButton->setText( tr( "&Browse" ) );
    BrowseButton->setAccel( QKeySequence( tr( "Alt+B" ) ) );
    QWhatsThis::add( BrowseButton, tr( "Browse for private key files" ) );
    m_pWhatsThis->setText( QString::null );
    QToolTip::add( m_pWhatsThis, tr( "What's this? (Shift+F1)" ) );
    OkButton->setText( tr( "&OK" ) );
    OkButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    ResetButton->setText( tr( "Rese&t" ) );
    ResetButton->setAccel( QKeySequence( tr( "Alt+T" ) ) );
    CancelButton->setText( tr( "&Cancel" ) );
    CancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

void SshKeyDialog::addClicked()
{
    qWarning( "SshKeyDialog::addClicked(): Not implemented yet" );
}

void SshKeyDialog::modifyClicked()
{
    qWarning( "SshKeyDialog::modifyClicked(): Not implemented yet" );
}

void SshKeyDialog::downClicked()
{
    qWarning( "SshKeyDialog::downClicked(): Not implemented yet" );
}

void SshKeyDialog::removeClicked()
{
    qWarning( "SshKeyDialog::removeClicked(): Not implemented yet" );
}

void SshKeyDialog::upClicked()
{
    qWarning( "SshKeyDialog::upClicked(): Not implemented yet" );
}

void SshKeyDialog::enterWhatsThisMode()
{
    qWarning( "SshKeyDialog::enterWhatsThisMode(): Not implemented yet" );
}

void SshKeyDialog::resetClicked()
{
    qWarning( "SshKeyDialog::resetClicked(): Not implemented yet" );
}

void SshKeyDialog::browseClicked()
{
    qWarning( "SshKeyDialog::browseClicked(): Not implemented yet" );
}

void SshKeyDialog::listClicked(QListBoxItem*)
{
    qWarning( "SshKeyDialog::listClicked(QListBoxItem*): Not implemented yet" );
}

